unit uRoomForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, AppEvnts, JvExStdCtrls, JvRichEdit;

type
  TRoomForm = class(TForm)
    RoomGroup: TGroupBox;
    InGameTitleEdit: TEdit;
    GameStartButton: TButton;
    ExitButton: TBitBtn;
    KickButton: TButton;
    GameChatingButton: TButton;
    GameChatingBar: TEdit;
    PlayerListView: TListView;
    chkStayTop: TCheckBox;
    chkJoinRing: TCheckBox;
    Button1: TButton;
    SpeedButton1: TSpeedButton;
    GameChatingScreen: TJvRichEdit;
    procedure GameChatingButtonClick(Sender: TObject);
    procedure KickButtonClick(Sender: TObject);
    procedure GameChatingButtonKeyPress(Sender: TObject; var Key: Char);
    procedure ExitButtonClick(Sender: TObject);
    procedure GameStartButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure chkStayTopClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure GameChatingScreenURLClick(Sender: TObject; const URLText: string;
      Button: TMouseButton);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RoomForm: TRoomForm;

implementation

{$R *.dfm}

uses uSettings, uInServerDialog, shellapi, clipbrd,
  jcldebug, ucore;

procedure TRoomForm.KickButtonClick(Sender: TObject);
begin
  Core.kickplayer(word(PlayerListView.Selected.Data));
end;

procedure TRoomForm.SpeedButton1Click(Sender: TObject);
begin
  inserverdialog.SetFocus;
end;

procedure TRoomForm.Button1Click(Sender: TObject);
begin
  Core.dropgame;
end;

procedure TRoomForm.chkStayTopClick(Sender: TObject);
begin
	if chkStayTop.Checked then
		self.FormStyle := fsStayOnTop
	else
    self.FormStyle := fsNormal;
end;

procedure TRoomForm.ExitButtonClick(Sender: TObject);
begin
  Core.LeaveGame;
  Close;
end;

procedure TRoomForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Settings.JoinRing := chkJoinRing.Checked;
	Settings.StayTop := chkStayTop.Checked;
  Settings.SetRoomFormPos(self.left, self.Top);
end;

procedure TRoomForm.FormShow(Sender: TObject);
var x, y: integer;
begin
	PlayerListView.Clear();
	GameChatingScreen.Clear();
	chkStayTop.Checked := Settings.StayTop;
	chkJoinRing.Checked := Settings.JoinRing;
  GameChatingBar.SetFocus;
	Settings.GetRoomFormPos(x, y);
	if (x = 0 ) then x := InServerDialog.Left + InServerDialog.GameListGroup.Left + 40;
	if (y = 0 ) then y := InServerDialog.Top + InServerDialog.GameListGroup.Top + 80;
	self.Left := x;
	self.Top := y;
end;

procedure TRoomForm.GameChatingButtonClick(Sender: TObject);
var tmp: string;
begin
  if GameChatingBar.Text = '' then exit;
  tmp := GameChatingBar.Text;
  if tmp[1] <> '`' then
    Core.SendGameChat(tmp)
  else
  begin
    delete(tmp, 1, 1);
    core.SendChat(tmp);
  end;
  GameChatingBar.Text := '';
  GameChatingBar.SetFocus;
end;

procedure TRoomForm.GameChatingButtonKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    GameChatingButtonClick(Sender);
    Key := #0;
  end;
end;

procedure TRoomForm.GameChatingScreenURLClick(Sender: TObject;
  const URLText: string; Button: TMouseButton);
begin
	ShellExecute(Handle, 'open', pchar(URLText), nil, nil, SW_SHOWNORMAL);
end;

procedure TRoomForm.GameStartButtonClick(Sender: TObject);
begin
  Core.startgame;
end;

end.
