unit OpenP2PCore;

interface

type
  p2pcore_callbacks = record
    p2p_chat_callback: procedure(nick: pansichar; msg: pansichar);
    p2p_add_delay_callback: function: boolean;
    p2p_game_callback: procedure(game: pansichar; playerno: integer; maxplayers: integer);
    p2p_end_game_callback: procedure;
    p2p_client_dropped_callback: procedure(nick: pansichar; playerno: integer);
    p2p_fodipp_callback: procedure(host: pansichar);
    p2p_hosted_game_callback: procedure(game: pansichar);
    p2p_ping_callback: procedure(PING: integer);
    p2p_ssrv_packet_recv_callback: procedure(cmd: pansichar; len: integer; sadr: pointer);
    p2p_peer_left_callback: procedure;
    p2p_peer_joined_callback: procedure;
  end;

bool __export p2p_core_cleanup(): boolean;
bool __export p2p_core_initialize(bool host, int port, char * appname, char * gamename, char * username): boolean;
bool __export p2p_core_connect(char * ip, int port): boolean;
void __export p2p_print_core_status();
void __export p2p_retransmit();
void __export p2p_drop_game();
void __export p2p_set_ready(bool bx);
void __export p2p_ping();
void __export p2p_send_chat(char * xxx);
bool __export p2p_disconnect(): boolean;
void __export p2p_step();
bool __export p2p_is_connected(): boolean;
void __export p2p_fodipp();

int __export p2p_modify_play_values(void *values, int size);
int __export p2p_core_get_port();

void __export p2p_set_callbacks(callbacks* arg_cb);


void p2p_send_ssrv_packet(char * cmd, int len, char * host, int port);
void p2p_send_ssrv_packet(char * cmd, int len, void * sadr);


implementation

end.
